use threads;
use threads::shared;
use strict;
use Test::Simple tests => 23;
use Time::HiRes qw (sleep);
use DE_EPAGES::Core::API::Object::MonitorShared;
use DE_EPAGES::Core::API::Object::MonitorThread;
use DE_EPAGES::Core::API::Script qw (RunScript);

my @LongSubTimes = (0.3, 0.4, 0.5, 0.6, 0.7, 0.1, 0.2, 0.3, 4, 10, 3); ##no critic qw(ProhibitMagicNumbers)
my @TimeOuts     = (  0,   0,   0,   0,   0,   0,   0,   0, 0,  1, 0);

sub veryLongSub {
    my ($Monitor, $howLong) = @_;

    sleep($howLong);
    $Monitor->set({
        'Content' => 'new content' . $howLong,
    });
}

RunScript( Sub => sub {
    # use a block to destroy monitor thread
    {
        my $Monitor : shared = DE_EPAGES::Core::API::Object::MonitorShared->new;
        my $MonitorThread = DE_EPAGES::Core::API::Object::MonitorThread->new(
            Timeout => 5,
            Monitor => $Monitor
        );

        for(my $Counter=0;$Counter < scalar @LongSubTimes; $Counter++) { # simulate requests
            $MonitorThread->run( 'Sub' => sub {
                veryLongSub($Monitor, $LongSubTimes[$Counter]);
            });
            ok ( $Monitor->isStarted == $TimeOuts[$Counter], 'timeout ' .$Counter);
            ok ( $Monitor->get('Content') eq 'new content'.$LongSubTimes[$Counter], 'content ' .$Counter);
        }
    }
    ok ( 1 , 'finished');
});
